/**********************************************************************
   Blocks -- Teemu Roos, April 6th, 2006
   (Donoho & Johnstone, Adapting to Unknown Smoothness via Wavelet
   Shrinkage, JASA, 1995)
 **********************************************************************/

#include <stdlib.h>
#include <stdio.h>

double tj[] = { .1,  .13, .15,  .23, .25, .40, .44, .65, .76, .78, .81};
double hj[] = {4.0,-5.0, 3.0, -4.0, 5.0,-4.2, 2.1, 4.3,-3.1, 2.1,-4.2};

double K(double t)
{
  if (t >= 0.0)
    return 1.0;
  else 
    return 0.0;
}

int main(int argc, char *argv[])
{
  int n, j;
  double t, val;

  if (argc < 2)
  {
    fprintf(stderr, "usage: %s <sample-size>\n", argv[0]);
    return -1;
  }
  n = atoi(argv[1]);

  for (t = 0.0; t <= 1.0; t += 1.0/(n-1))
  {
    val = 0.0;
    for (j = 0; j < 11; j++)
      val += hj[j]*K(t-tj[j]);
    printf("%lf\n", val);
  }

  return 0;
}
