/**********************************************************************
   Doppler -- Teemu Roos, April 6th, 2006
   (Donoho & Johnstone, Adapting to Unknown Smoothness via Wavelet
   Shrinkage, JASA, 1995)
 **********************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <math.h>

#define PI 3.141592653589793
#define epsilon .05

int main(int argc, char *argv[])
{
  int n;
  double t, val;

  if (argc < 2)
  {
    fprintf(stderr, "usage: %s <sample-size>\n", argv[0]);
    return -1;
  }
  n = atoi(argv[1]);

  for (t = 0.0; t <= 1.0; t += 1.0/(n-1))
  {
    val = sqrt(t*(1-t)) * sin(2*PI*(1+epsilon)/(t+epsilon));
    printf("%lf\n", val);
  }

  return 0;
}
