/**********************************************************************
   Heavisine -- Teemu Roos, April 6th, 2006
   (Donoho & Johnstone, Adapting to Unknown Smoothness via Wavelet
   Shrinkage, JASA, 1995)
 **********************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <math.h>

#define PI 3.141592653589793

double sgn(double t)
{
  if (t >= 0.0)
    return 1.0;
  else
    return -1.0;
}

int main(int argc, char *argv[])
{
  int n;
  double t, val;

  if (argc < 2)
  {
    fprintf(stderr, "usage: %s <sample-size>\n", argv[0]);
    return -1;
  }
  n = atoi(argv[1]);

  for (t = 0.0; t <= 1.0; t += 1.0/(n-1))
  {
    val = 4.0*sin(4.0*PI*t) - sgn(t-.3) - sgn(.72-t);
    printf("%lf\n", val);
  }

  return 0;
}
